<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useDateStore } from '@/stores/date';
import { useOrderStore } from '@/stores/order'
import type { OrderItems } from '@/types/OrderItems'

const authStore = useAuthStore()
const orderStore = useOrderStore()
const dateStore = useDateStore()

const currentUser = authStore.getCurrentUser()

let unitOrder = 0

function Inc(item: OrderItems) {
  unitOrder++
  item.qty = item.qty + unitOrder
  unitOrder = 0
  orderStore.calOrder()
}

function Dec(item: OrderItems) {
  if (item.qty < 2) {
    orderStore.removeReceiptItem(item)
  }
  unitOrder--
  item.qty = item.qty - -unitOrder
  unitOrder = 0
  orderStore.calOrder()
}

</script>
<template>
  <v-row justify="center">
    <v-dialog v-model="orderStore.orderDialog" persistent width="500px">
      <v-card>
        <v-card-title>Order List Material</v-card-title>
        <v-divider></v-divider>
        <v-card-text style="height: 30px"> </v-card-text>
        <v-row style="margin-left: 1px"
          ><v-col>วันที่ {{ dateStore.currentDate() }}</v-col></v-row
        >
        <v-row style="margin-left: 7px">
          __________________________________________________________________</v-row
        >
        <v-row
          ><v-col style="margin-left: 10px">พนักงาน</v-col><v-col></v-col
          ><v-col>{{ currentUser?.fullName }}</v-col></v-row
        >
        <v-row style="margin-left: 7px">
          __________________________________________________________________</v-row
        >
        <v-row><v-col style="margin-left: 10px">รายการทั้งหมด</v-col></v-row>
        <v-row v-for="(item, index) in orderStore.orderItems" :key="index">
          <v-col style="margin-left: 10px">{{ item.name }}</v-col>
          <v-col style="margin-left: 10px">
            <v-sheet width="80px" elevation="2">
              <v-btn
                icon="mdi-minus"
                density="compact"
                size="small"
                style="margin-left: 10px"
                @click="Dec(item)"
              ></v-btn>
              {{ item.qty }}
              <v-btn icon="mdi-plus" density="compact" size="small" @click="Inc(item)"></v-btn>
            </v-sheet>
          </v-col>
          <v-col>
            <v-btn
              icon="mdi-delete"
              density="compact"
              size="small"
              @click="orderStore.removeReceiptItem(item)"
            ></v-btn>
          </v-col>
        </v-row>
        <v-row style="margin-left: 7px">
          __________________________________________________________________</v-row
        >
        <v-row
          ><v-col style="margin-left: 10px">จำนวน Order</v-col><v-col></v-col
          ><v-col>{{ orderStore.order!.totalQty }}</v-col></v-row
        >
        <v-row
          ><v-col style="margin-left: 10px">ส่วนลด</v-col><v-col></v-col><v-col>-</v-col></v-row
        >
        <v-row style="margin-left: 5px"
          >====================================================</v-row
        >
        <v-row
          ><v-col style="font-size: x-large; font-style: inherit; margin-left: 10px">ยอดสุทธิ</v-col
          ><v-col></v-col
          ><v-col style="font-size: x-large; font-style: inherit">{{
            orderStore.order!.totalPrice
          }}</v-col></v-row
        >
        <v-row style="margin-left: 5px"
          >====================================================</v-row
        >
        <v-card-actions>
          <v-btn
            color="primary"
            variant="text"
            @click="orderStore.closeDialog(), orderStore.initOrder()"
          >
            Remove All</v-btn
          >
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" @click="orderStore.closeDialog()"> Cancel </v-btn>
          <v-btn color="primary" variant="text" @click="orderStore.Confirm()"> Order </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
  <v-dialog v-model="orderStore.conDialog" max-width="500px">
    <v-card>
      <v-card-title class="text-h5" style="text-align: center">Confirm?</v-card-title>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" variant="text" @click="orderStore.closeDialogCon()">Cancel</v-btn>
        <v-btn color="primary" variant="text" @click="orderStore.Order() ">OK</v-btn>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
